uses
  SysUtils, ScktComp,windows,messages;
type
  TCust=class
    procedure SockConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure SockError(Sender: TObject; Socket: TCustomWinSocket;
    ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  end;

var
  Handle:HWND;
  MSG:TMsg;
  Result:integer;
  ServSock:TClientSocket;
  Cust:TCust;
  TypeOfAddr:byte;

  function WndProc(Hwnd:HWND;msg:Integer;WParam:WPARAM;
           LParam:LPARAM):LRESULT;stdcall;
  begin
    case Msg of
      WM_DESTROY:begin
        ServSock.Close;
        ServSock.Free;
        PostQuitMessage(0);
        Result:=0;
      end
    else
      Result:=DefWindowProc(Hwnd,Msg,WParam,LParam);
    end;
  end;

  procedure TCust.SockConnect(Sender: TObject;Socket: TCustomWinSocket);
  begin
    Socket.SendText(ParamStr(3));
    Socket.Close;
    PostMessage(Handle,WM_QUIT,0,0);
  end;

  procedure TCust.SockError(Sender: TObject; Socket: TCustomWinSocket;
    ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  begin
    if TypeOfAddr in [1,0] then
    MessageBox(Handle,PAnsiChar('Not connect to '+ServSock.host+' '+
              ServSock.Address),'Socket error',
              MB_OK or MB_ICONERROR);
    PostMessage(Handle,WM_QUIT,0,0);
  end;

begin
  //        
  if ParamCount=0 then begin
    MessageBox(Handle,'LANsend.exe A B C'+
               #13#13'A - server sock (host or ip)'+
               #13'B - type of A'+
               #13'0-ip, 1-host with error message'+
               #13'10-ip, 11-host without error message'+
               #13'C - text to send',
               'LANSend v1.2',
               MB_OK or MB_ICONASTERISK);
    halt;
  end;
  ServSock:=TClientSocket.Create(nil);
  ServSock.OnConnect:=Cust.SockConnect;
  ServSock.OnError:=Cust.SockError;
  TypeOfAddr:=strtoint(ParamStr(2));
  case TypeOfAddr of
  0,10:ServSock.Address:=ParamStr(1);
  1,11:ServSock.Host:=ParamStr(1);
  end;
  ServSock.Port:=8080;
  ServSock.Open;
  while GetMessage(Msg,0,0,0)do
  begin
    TranslateMessage(MSG);
    DispatchMessage(MSG);
  end;
end.
