unit uMain;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, Menus, UTrayIcon, Buttons, ImgList, ExtCtrls,
  CopyScktComp, ShellAPI;

type
  TfMain = class(TForm)
    mChat: TMemo;
    clbUsers: TCheckListBox;
    cbNetSend: TCheckBox;
    cbFixNetSend: TCheckBox;
    pmMain: TPopupMenu;
    tiTray: TTrayIcon;
    pmTray: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    eSend: TEdit;
    eNick: TEdit;
    Image1: TImage;
    cbServer: TCheckBox;
    ssServer: TServerSocket;
    N5: TMenuItem;
    N6: TMenuItem;
    lbYourHost: TLabel;
    N7: TMenuItem;
    sbMenu: TSpeedButton;
    sbClear: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    //procedure CreateParams(var Params:TCreateParams);override;
    procedure FormCreate(Sender: TObject);
    procedure cbFixNetSendClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure stMenuClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mChatChange(Sender: TObject);
    procedure eSendKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure N5Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure cbServerClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ssServerClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure N7Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure pmTrayPopup(Sender: TObject);
    procedure sbClearClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure eNickChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    procedure AppOnMessage(VAR Msg: TMsg; VAR Handled: Boolean);
    procedure HotKey(var msg:TWMHotKey);message WM_HOTKEY;
    //     
  public
    { Public declarations }
  end;
const MyPrg='Gott_LANChat';
var   {$I+}
  fMain: TfMain;
  OSVerXP:boolean=false;//    
  SC_MENUMSG,SC_MENUMSGABOUT:Cardinal;//    
  HookLib:dword;//  

implementation
uses uAbout, uSet, uDop;
{$R *.dfm}

procedure TfMain.FormCreate(Sender: TObject);
var OsVer:TOSVersionInfoA;
    hMenuh:HMENU;
    Request:string;
    i:byte;
begin
  SC_MENUMSG:=RegisterWindowMessage('SC_MENUMSG2004');
  SC_MENUMSGABOUT:=RegisterWindowMessage('SC_MENUMSGABOUT2004');
  HMenuH:=GetSystemMenu(Application.Handle,False);
  if hMenuh<>0 then DeleteMenu(hMenuh,SC_CLOSE,MF_BYCOMMAND);
  if hMenuh<>0 then DeleteMenu(hMenuh,SC_MINIMIZE,MF_BYCOMMAND);
  if hMenuh<>0 then DeleteMenu(hMenuh,SC_RESTORE,MF_BYCOMMAND);
  OsVer.dwOSVersionInfoSize:=sizeof(OsVer);
  GetVersionEx(OsVer);
  if OsVer.dwMajorVersion<>5 then begin
    cbNetSend.Enabled:=false;
    cbFixNetSend.Enabled:=false;
  end
  else OSVerXP:=true;
  with Settings do begin
    ProgDir:=ExtractFileDir(ParamStr(0));
    IniName:=ProgDir+'\Settings.ini';
    RestoreSett;
    AlphaBlendValue:=Round((100-Transp)*(255/100));
    Color:=MyColor;
    eNick.Text:=Settings.NickName;
  end;
  Users:=TUsers.create;
  cbServerClick(nil);
  for i:=Settings.Range[1] to Settings.Range[2]do begin
    PingUsers('192.168.'+inttostr(Settings.Range[3])+'.'+inttostr(i),1);
  end;
  CustUsers:=TCustUsers.create;
  CustUsers.LoadUserList;
  if CustUsers.UsersCount>0 then
  for i:=0 to CustUsers.UsersCount-1 do begin
    Request:=CustUsers.User[i].A+' 1'+inttostr(CustUsers.User[i].AType)+
    ' @Ping1'+Settings.NickName;
    ShellExecute(0,nil,'LANSend',PAnsiChar(Request),nil,SW_SHOWNORMAL);
  end;
  //    
  AppendMenu(GetSystemMenu(Application.Handle,False),
  MF_STRING,SC_MENUMSGABOUT,' ');
  AppendMenu(GetSystemMenu(Application.Handle,False),
  MF_STRING,SC_MENUMSG,'');
  Application.OnMessage:=AppOnMessage;//  
  RegisterHotKey(Handle,1,MOD_ALT or MOD_CONTROL,$4A);
end;

procedure TfMain.cbFixNetSendClick(Sender: TObject);
begin
  if cbFixNetSend.Checked then begin
    cbNetSend.Checked:=true;
    cbNetSend.Enabled:=false;
  end
  else begin
    cbNetSend.Checked:=false;
    cbNetSend.Enabled:=true;
  end;
end;

procedure TfMain.N4Click(Sender: TObject);
begin
  Halt;
end;

procedure TfMain.N3Click(Sender: TObject);
begin
  Application.Minimize;
  ShowWindow(Application.Handle,SW_HIDE);
  tiTray.TrayShow;
end;

procedure TfMain.N1Click(Sender: TObject);
begin
  Application.Restore;
  tiTray.TrayHide;
end;

procedure TfMain.stMenuClick(Sender: TObject);
begin
  pmMain.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TfMain.N2Click(Sender: TObject);
begin
  halt;
end;

procedure TfMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if(ssCtrl in Shift)and(chr(Key)in['Q','q','',''])then
  N4Click(nil);
  if(ssCtrl in Shift)and(chr(Key)in['M','m','',''])then
  N3Click(nil);

  if not OSVerXP then exit;
  if(ssCtrl in Shift)and(chr(Key)in['F','f','',''])then begin
    cbFixNetSend.Checked:=not cbFixNetSend.Checked;
    cbFixNetSendClick(nil);
  end;
  if(ssCtrl in Shift)and(chr(Key)in['N','n','',''])then
  cbNetSend.Checked:=not cbNetSend.Checked;
end;

procedure TfMain.mChatChange(Sender: TObject);
var i:byte;
begin
 if mChat.Lines.Count>300 then begin
   for i:=1 to 50 do
   mChat.Lines.Delete(0);
   SendMessage(mChat.Handle, EM_SCROLL, SB_LINEDOWN, 0);// 
 end;
end;

procedure TfMain.eSendKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:word;
    TextToSend:string;
begin
  if Key<>13 then exit;
  if clbUsers.Count=0 then exit;
  TextToSend:=eNick.Text+':'#0160+eSend.Text;
  if cbNetSend.Checked then begin//  
    for i:=0 to clbUsers.Count-1 do
    if clbUsers.Checked[i] then
    ShellExecute(0,nil,'net',
    PAnsiChar(' send '+Users.User[i].A+' '
    +TextToSend),nil,SW_HIDE);
    cbNetSend.Checked:=cbFixNetSend.Checked;
  end
  else begin//  
    for i:=1 to length(TextToSend)do
    if TextToSend[i]=' 'then TextToSend[i]:=#0160;
    for i:=0 to clbUsers.Count-1 do
    if clbUsers.Checked[i] then
    ShellExecute(0,nil,'LANsend',
    PAnsiChar(Users.User[i].A+' '+inttostr(Users.User[i].AType)+' '
    +TextToSend),nil,SW_NORMAL);
    mChat.Lines.Add(eNick.Text+': '+eSend.Text);
  end;
  eSend.Clear;
end;

procedure TfMain.N5Click(Sender: TObject);
begin//        
  fAbout:=TfAbout.Create(nil);
  fAbout.ShowModal;
  fAbout.Free;
end;

procedure TfMain.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin//          
  If Button = mbLeft Then
  Begin
    ReleaseCapture;
    SendMessage(Handle,WM_NCLBUTTONDOWN,HTCAPTION,0);
  End
end;

procedure TfMain.FormPaint(Sender: TObject);
var i:byte;
begin//     
  Canvas.Pen.Color:=Settings.LineColor;
  Canvas.MoveTo(0,0);
  Canvas.LineTo(fMain.ClientWidth-1,0);
  Canvas.LineTo(fMain.ClientWidth-1,fMain.ClientHeight-1);
  Canvas.LineTo(0,fMain.ClientHeight-1);
  Canvas.LineTo(0,0);
  Canvas.MoveTo(fMain.ClientWidth-1,26);
  Canvas.LineTo(0,26);
  Canvas.MoveTo(1,1);
  for i:=1 to 25 do begin//    
    with Settings do
    Canvas.Pen.Color:=
    RGB(255-i*10*Byte(R),255-i*10*Byte(G),255-i*10*Byte(B));
    Canvas.MoveTo(1,i);
    Canvas.LineTo(fMain.ClientWidth-1,i);
  end
end;

procedure TfMain.N6Click(Sender: TObject);
begin
  fSet:=TfSet.Create(nil);
  if fSet.ShowModal=mrOk then begin;
    with Settings do begin
      fMain.Color:=MyColor;
      fMain.AlphaBlendValue:=Round((100-Transp)*(255/100));
      fMain.Font.Color:=FontColor;
      Invalidate;
      clbUsers.Hide;
      clbUsers.Show;
      case ClickOnTray of
      0:begin N1.Visible:=true; N2.Visible:=true;
        pmTray.OnPopup:=nil; end;
      1:begin N1.Visible:=false; N2.Visible:=false;
        pmTray.OnPopup:=pmTrayPopup; end;
      end;
    end;
  end;
  fSet.Free;
end;

procedure TfMain.cbServerClick(Sender: TObject);
begin
  ssServer.Active:=cbServer.Checked;
  lbYourHost.Caption:='Host: '+ssServer.Socket.LocalHost;
end;

procedure TfMain.AppOnMessage(var Msg: TMsg; var Handled: Boolean);
begin
  if Msg.message<>WM_SYSCOMMAND then exit;
  if msg.wParam=SC_MENUMSG then N4Click(nil);
  if msg.wParam=SC_MENUMSGABOUT then N5Click(nil);
end;

procedure TfMain.FormDestroy(Sender: TObject);
var
  i:byte;
  Request:string;
begin
//   
  UnregisterHotKey(Handle,1);
  tiTray.TrayHide;
  Settings.NickName:=eNick.Text;
  Settings.SaveSett;
  CustUsers.SaveUserList;
  //,  
  for i:=Settings.Range[1] to Settings.Range[2]do begin
    PingUsers('192.168.0.'+inttostr(i),0);
  end;
  if CustUsers.UsersCount>0 then
  for i:=0 to CustUsers.UsersCount-1 do begin
    Request:=CustUsers.User[i].A+' 1'+inttostr(CustUsers.User[i].AType)+
    ' @Ping0'+Settings.NickName;
    ShellExecute(0,nil,'LANSend',PAnsiChar(Request),nil,SW_SHOWNORMAL);
  end;
  Users.free;
  CustUsers.free;
  GlobalDeleteAtom(GlobalFindAtom(MyPrg));
end;

procedure TfMain.ssServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  RecText,RemAddr:string;
  i:byte;
  Num:byte;

  procedure PlayBeep;
  begin
    windows.Beep(Settings.Freq,50);
    windows.Beep(Settings.Freq+100,50);
    windows.Beep(Settings.Freq+200,50);
  end;
begin
  RecText:=Socket.ReceiveText;
  RemAddr:=Socket.RemoteAddress;
  if pos('@Ping',RecText)<>0 then begin
    delete(RecText,1,5);
    Num:=0;
    if RecText[1]='1' then PingUsers(RemAddr,2);
    if RecText[1] in ['1','2']then begin
      delete(RecText,1,1);
      if Users.UsersCount<>0 then
      for i:=0 to Users.UsersCount-1 do
      Num:=byte(Users.User[i].A=RemAddr)*i+byte(Users.User[i].A=RemAddr);
      if not boolean(num) then begin
        Users.AddUser(RemAddr,0);
        clbUsers.Items.Add(RecText);
      end
      else clbUsers.Items.Strings[Num-1]:=RecText;
    end;
    if RecText[1]='0'then begin
      delete(RecText,1,1);
      Num:=0;
      if Users.UsersCount<>0 then
      for i:=0 to Users.UsersCount-1 do
      Num:=byte(Users.User[i].A=RemAddr)*i+byte(Users.User[i].A=RemAddr);
      if boolean(Num) then begin
        Users.DelUser(Num-1);
        clbUsers.Items.Delete(Num-1);
      end;
    end;
    exit;
  end;
  mChat.Lines.Add(RecText);
  if Settings.Signal[4] and tiTray.TrayShow then N1Click(nil);
  if Settings.Signal[1] then FlashWindow(Application.Handle,true);
  if Settings.Signal[2] then PlayBeep;
  if Settings.Signal[3] then SetForegroundWindow(Application.Handle);
end;

procedure TfMain.N7Click(Sender: TObject);
begin
  ShellExecute(Handle,nil,
  PChar(Settings.ProgDir+'\Help.hlp'),nil,nil,SW_SHOW);
end;

procedure TfMain.SpeedButton2Click(Sender: TObject);
var i:byte;
    Request:string;
begin
  for i:=Settings.Range[1] to Settings.Range[2]do begin
    PingUsers('192.168.0.'+inttostr(i),1);
  end;
  if CustUsers.UsersCount>0 then
  for i:=0 to CustUsers.UsersCount-1 do begin
    Request:=CustUsers.User[i].A+' 1'+inttostr(CustUsers.User[i].AType)+
    ' @Ping1'+Settings.NickName;
    ShellExecute(0,nil,'LANSend',PAnsiChar(Request),nil,SW_SHOWNORMAL);
  end;
end;

procedure TfMain.pmTrayPopup(Sender: TObject);
begin
  N1Click(nil);
end;

procedure TfMain.sbClearClick(Sender: TObject);
begin
  mChat.Clear;
end;

procedure TfMain.SpeedButton1Click(Sender: TObject);
begin
  N4Click(nil);
end;

procedure TfMain.eNickChange(Sender: TObject);
begin
  Settings.NickName:=eNick.Text;
end;

procedure TfMain.HotKey(var msg: TWMHotKey);
begin
  if msg.HotKey=1 then
  begin
    N1Click(nil);
    SetForegroundWindow(Application.Handle);
  end;
end;

procedure TfMain.FormActivate(Sender: TObject);
var i:byte;
begin
  for i:=20 to Round((100-Settings.Transp)*(255/100))do
  begin
    AlphaBlendValue:=i;
    Application.ProcessMessages;
  end;
end;

procedure TfMain.SpeedButton3Click(Sender: TObject);
begin
  N3Click(nil);
end;

end.
