unit uSet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Spin, Inifiles, CheckLst, ShellAPI;

type
  TfSet = class(TForm)
    Label1: TLabel;
    seTransparent: TSpinEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ColorDialog1: TColorDialog;
    sbWindowColor: TSpeedButton;
    shSampleColor: TShape;
    sbFontColor: TSpeedButton;
    shFontColor: TShape;
    sbLineColor: TSpeedButton;
    shLineColor: TShape;
    cbRed: TCheckBox;
    cbGreen: TCheckBox;
    cbBlue: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    cbBlink: TCheckBox;
    cbPeek: TCheckBox;
    cbTop: TCheckBox;
    cbTray: TCheckBox;
    leFreq: TLabeledEdit;
    seFin: TSpinEdit;
    seStart: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    cbClickOnTray: TComboBox;
    eIP3: TEdit;
    lbCust: TListBox;
    Label8: TLabel;
    leAddr: TLabeledEdit;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sbWindowColorClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure sbFontColorClick(Sender: TObject);
    procedure sbLineColorClick(Sender: TObject);
    procedure seFinChange(Sender: TObject);
    procedure seStartChange(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  //   ,        
  //     
  //       , 
  TSettings=object
    Transp:byte;
    MyColor:TColor;
    LineColor:TColor;
    FontColor:TColor;
    ProgDir:string;
    IniName:string;
    NickName:string;
    Signal:array[1..4]of boolean;//1- 2- 3-
    ValToWrite:^dword;
    Freq:dword;
    R,G,B:boolean;
    Ini:TIniFile;
    Range:array[1..3]of byte;
    RangeWrite:^dword;
    ClickOnTray:byte;
    procedure SaveSett;
    procedure RestoreSett;
  end;
var
  fSet: TfSet;
  Settings:TSettings;

implementation
uses uDop;
{$R *.dfm}

procedure TfSet.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If ssLeft In Shift Then
  Begin
    ReleaseCapture;
    SendMessage(Handle,WM_NCLBUTTONDOWN,HTCAPTION,0);
  End;
end;

procedure TfSet.SpeedButton1Click(Sender: TObject);
begin// 
  with Settings do begin
    Transp:=seTransparent.Value;
    MyColor:=shSampleColor.Brush.Color;
    LineColor:=shLineColor.Brush.Color;
    FontColor:=shFontColor.Brush.Color;
    R:=cbRed.Checked;
    G:=cbGreen.Checked;
    B:=cbBlue.Checked;
    Signal[1]:=cbBlink.Checked;
    Signal[2]:=cbPeek.Checked;
    Signal[3]:=cbTop.Checked;
    Signal[4]:=cbTray.Checked;
    Range[1]:=seStart.Value;
    Range[2]:=seFin.Value;
    try
      Range[3]:=strtoint(eIP3.Text);
    except
      Range[3]:=0;
    end;
    ClickOnTray:=cbClickOnTray.ItemIndex;
    try
      Freq:=StrToInt(leFreq.Text);
    except
      Freq:=4000;
    end;
  end;
  ModalResult:=mrOk;
end;

procedure TfSet.FormCreate(Sender: TObject);
var i:byte;
begin
  with Settings do begin
    seTransparent.Value:=Transp;
    shSampleColor.Brush.Color:=MyColor;
    shFontColor.Brush.Color:=FontColor;
    shLineColor.Brush.Color:=LineColor;
    cbRed.Checked:=R;
    cbGreen.Checked:=G;
    cbBlue.Checked:=B;
    cbBlink.Checked:=Signal[1];
    cbPeek.Checked:=Signal[2];
    cbTop.Checked:=Signal[3];
    cbTray.Checked:=Signal[4];
    seStart.Value:=Range[1];
    seFin.Value:=Range[2];
    eIP3.Text:=inttostr(Range[3]);
    cbClickOnTray.ItemIndex:=ClickOnTray;
    leFreq.Text:=IntToStr(Freq);
  end;
  if CustUsers.UsersCount<>0 then
  for i:=0 to CustUsers.UsersCount-1 do
  lbCust.Items.Add(CustUsers.User[i].A);
end;

{ Settings }

procedure TSettings.RestoreSett;
begin
  ValToWrite:=@Signal;//     
  RangeWrite:=@Range;
  ini:=TIniFile.Create(IniName);
  MyColor:=ini.ReadInteger('Skin','MyColor',clBlack);
  FontColor:=ini.ReadInteger('Skin','FontColor',clLime);
  LineColor:=ini.ReadInteger('Skin','LineColor',clWhite);
  Transp:=ini.ReadInteger('Skin','Transp',0);
  R:=Ini.ReadBool('Skin','Red',true);
  G:=Ini.ReadBool('Skin','Green',true);
  B:=Ini.ReadBool('Skin','Blue',true);
  NickName:=ini.ReadString('General','Nick','User');
  ValToWrite^:=ini.ReadInteger('General','Signal',0);
  RangeWrite^:=ini.ReadInteger('General','Range',$0f01);
  Freq:=ini.ReadInteger('General','Freq',4000);
  ClickOnTray:=ini.ReadInteger('General','ClickOnTray',0);
  ini.Free;
end;

procedure TSettings.SaveSett;
begin
  ini:=TIniFile.Create(IniName);
  ini.WriteInteger('Skin','MyColor',MyColor);
  ini.WriteInteger('Skin','Transp',Transp);
  ini.WriteInteger('Skin','FontColor',FontColor);
  ini.WriteInteger('Skin','LineColor',LineColor);
  ini.WriteString('General','Nick',NickName);
  ini.WriteBool('Skin','Red',R);
  ini.WriteBool('Skin','Green',G);
  ini.WriteBool('Skin','Blue',B);
  ini.WriteInteger('General','Signal',ValToWrite^);
  ini.WriteInteger('General','Range',RangeWrite^);
  ini.WriteInteger('General','Freq',Freq);
  ini.WriteInteger('General','ClickOnTray',ClickOnTray);
  ini.Free;
end;

procedure TfSet.sbWindowColorClick(Sender: TObject);
begin
  if not ColorDialog1.Execute then exit;
  shSampleColor.Brush.Color:=ColorDialog1.Color;
end;

procedure TfSet.SpeedButton2Click(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TfSet.sbFontColorClick(Sender: TObject);
begin
  if not ColorDialog1.Execute then exit;
  shFontColor.Brush.Color:=ColorDialog1.Color;
end;

procedure TfSet.sbLineColorClick(Sender: TObject);
begin
  if not ColorDialog1.Execute then exit;
  shLineColor.Brush.Color:=ColorDialog1.Color;
end;

procedure TfSet.seFinChange(Sender: TObject);
begin
  seStart.MaxValue:=seFin.Value;
end;

procedure TfSet.seStartChange(Sender: TObject);
begin
 seFin.MinValue:=seStart.Value+1;
end;

procedure TfSet.FormPaint(Sender: TObject);
begin
  Canvas.Pen.Style:=psInsideFrame;
  Canvas.Pen.Color:=clLime;
  Canvas.MoveTo(2,2);
  Canvas.LineTo(Self.ClientWidth-3,2);
  Canvas.LineTo(Self.ClientWidth-3,Self.ClientHeight-3);
  Canvas.LineTo(2,self.ClientHeight-3);
  Canvas.LineTo(2,2);
end;

procedure TfSet.SpeedButton3Click(Sender: TObject);
begin
  if leAddr.Text='' then exit;
  CustUsers.AddUser(leAddr.Text,byte(pos('192.168.',leAddr.Text)<>1));
  lbCust.Items.Add(leAddr.Text);
end;

procedure TfSet.SpeedButton4Click(Sender: TObject);
begin
  if lbCust.ItemIndex=-1 then exit;
  CustUsers.DelUser(lbCust.ItemIndex);
  lbCust.Items.Delete(lbCust.ItemIndex);
end;

end.
